## gecode-snapshot 6.2.0+git20240207

=== debian/changelog ===
gecode-snapshot (6.2.0+git20240207-2) unstable; urgency=medium

  * Use dh for debian/rules.
  * Fix changelog build (Closes: #1092423)

 -- Kari Pahula <kaol@debian.org>  Thu, 13 Feb 2025 17:35:47 +0200

gecode-snapshot (6.2.0+git20240207-1) unstable; urgency=medium

  * Initial release (Closes: #1074772)
  * Repackage Gecode with git snapshot to get a newer flatzinc without
    touching the library part
  * Build Gecode as static library only and use it to build FlatZinc

 -- Kari Pahula <kaol@debian.org>  Fri, 05 Jul 2024 11:06:52 +0300
