=== debian/control ===
Source: gecode-snapshot
Priority: optional
Maintainer: Kari Pahula <kaol@debian.org>
Build-Depends: debhelper (>= 13), debhelper-compat (= 13), libmpfr-dev, flex, bison, qt6-base-dev, libboost-dev
Standards-Version: 4.7.0
Section: libs
Homepage: https://www.gecode.org/
Vcs-Browser: https://salsa.debian.org/kaol/gecode-snapshot
Vcs-Git: https://salsa.debian.org/kaol/gecode-snapshot.git

Package: gecode-flatzinc
Section: devel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: minizinc
Provides: flatzinc
Replaces: flatzinc (<< 6.2.0+git20240207)
Breaks: flatzinc (<< 6.2.0+git20240207)
Homepage: https://www.gecode.org/flatzinc.html
Description: constraint problem modelling language
 FlatZinc is a low-level modelling language for constraint
 problems. It is designed to be easily interfaceable to constraint
 solvers (like Gecode). For more information on FlatZinc, please refer
 to the MiniZinc pages of the G12 project <https://www.minizinc.org/>.
