## gecode-snapshot 6.2.0+git20260120

=== debian/changelog ===
gecode-snapshot (6.2.0+git20260120-1) unstable; urgency=medium

  * New upstream snapshot.
  * Standards-Version 4.7.3
  * Remove Priority field from debian/control

 -- Kari Pahula <kaol@debian.org>  Mon, 23 Feb 2026 21:56:43 +0200
