=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: gecode-snapshot
-Priority: optional
 Maintainer: Kari Pahula <kaol@debian.org>
 Build-Depends: debhelper (>= 13), debhelper-compat (= 13), libmpfr-dev, flex, bison, qt6-base-dev, libboost-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Section: libs
 Homepage: https://www.gecode.org/
 Vcs-Browser: https://salsa.debian.org/kaol/gecode-snapshot
